#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PASSWD_FILE "/etc/passwd"
#define MAX_LEN 1024

int main(int argc, char *argv[]) {
    if (argc != 2) {
	fprintf(stderr,
		"too few arguements\n"
		"use: %s filename\n",
		argv[0]);
	return -1;
    }    
    FILE *fd=NULL;
    FILE *fout=NULL;
    char *buffer= NULL;
    if ((fd=fopen(PASSWD_FILE, "r")) == NULL) {
	perror("opening password file");
	goto error;
    }
    if ((fout=fopen(argv[1], "w")) == NULL) {
	perror("opening output file");
	goto error;
    }    
    if ((buffer=malloc(MAX_LEN*sizeof(char))) == NULL) {
	perror("malloc buffer");
	goto error;       
    }
    while(fgets(buffer, MAX_LEN, fd) != NULL) {
	char *newline;
	// controllo di aver lette tutta una riga
	if ((newline=strchr(buffer, '\n')) == NULL) {
	    fprintf(stderr, "something went wrong, please consider to increase MAX_LEN (%d)\n", MAX_LEN);
	    goto error;
	}
	*newline = '\0';  // tolgo lo '\n'
	char *colons ;
	if ((colons=strchr(buffer, ':')) == NULL) {
	    fprintf(stderr, "wrong file format\n");
	    goto error;
	}
	*colons = '\0';	// sostituisco : con \0
	fprintf(fout, "%s\n", buffer);
    }
    fclose(fd);
    fclose(fout);
    free(buffer);

    return 0;
 error:
    if (fd) fclose(fd);
    if (fout) fclose(fout);
    if (buffer) free(buffer);
    exit(EXIT_FAILURE);
}
